#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin>>t;
    for(int k=0; k<t; k++)
    {


    int n;
    cin>>n;
    long long int a[n];
    long long int unos, brnula1=0, brnula2=0;
    int pamti1, pamti2;
    for(int i=0; i<n; i++)
    {
        cin>>unos;
        a[i]=unos;
        if(a[i]==0) brnula1++;
        else pamti1=i;
    }
    map<long long int, int> mesta;
    long long int b[n];
    for(int i=0; i<n; i++)
    {
        cin>>unos;
        if(unos<0) mesta[abs(unos)]=-(i+1);
        else mesta[abs(unos)]=i+1;
        if(unos==0) brnula2++;
        else pamti2=i;
        b[i]=unos;
    }
    bool jednaki=true;
    for(int i=0; i<n; i++)
    {
        if(a[i]!=b[i]) jednaki=false;
    }
    if(jednaki)
    {
        cout<<"DA"<<"\n";
        continue;
    }
    if(brnula1==brnula2 && brnula1>=n-1)
    {
        if(brnula1==n){cout<<"DA"<<"\n"; continue;}
        else
        {
            if(abs(a[pamti1])==abs(b[pamti2]))
    {

    if(a[pamti1]/b[pamti2]<0)
    {
        if((pamti2-pamti1)%2==0)
        {
            cout<<"NE"<<"\n";
            continue;
        }
        else
        {
            cout<<"DA"<<"\n";
            continue;
        }
    }
    else
    {
        if((pamti2-pamti1)%2==0)
        {
            cout<<"DA"<<"\n";
            continue;
        }
        else
        {
            cout<<"NE"<<"\n";
            continue;
        }
    }
    }
    else
    {
        cout<<"NE"<<"\n";
        continue;
    }
        }
    }
    else
    {
    bool ispunjava=true;
    int prvi, drugi, dm;
    for(int i=0; i<n; i++)
    {
        prvi=i;
        drugi=mesta[abs(a[prvi])];
        if(drugi<0)
        {
            drugi=-drugi;
            dm=-abs(a[prvi]);
        }
        else dm=abs(a[prvi]);
        drugi--;
        if(a[prvi]/dm<0)
        {
            if(abs(prvi-drugi)%2==0)
            {
                ispunjava=false;
                break;
            }
        }
        else
        {
            if(abs(prvi-drugi)%2!=0)
            {
                ispunjava=false;
                break;
            }
        }
    }
    if(ispunjava)
    {
        cout<<"DA"<<"\n";
    }
    else cout<<"NE"<<"\n";
    }


    }


}